#!/usr/bin/env python
#-*-coding:utf-8-*-
from multiprocessing import Process, Pool, Lock
import re
import urllib, json

from myutil import httptools

market_list = {'US':{"lang":"en_US","marketPlace":"ATVPDKIKX0DER","currency":"USD",'url':'https://sellercentral.amazon.com/fba/profitabilitycalculator/','host':1},
            'CA':{"lang":"en_CA","marketPlace":"A2EUQ1WTGCTBG2","currency":"CAD",'url':'https://sellercentral.amazon.com/fba/profitabilitycalculator/','host':1},
            'MX':{"lang":"es_MX","marketPlace":"A1AM78C64UM0Y8","currency":"MXN",'url':'https://sellercentral.amazon.com/fba/profitabilitycalculator/','host':1},
            'JP':{"lang":"ja_JP","marketPlace":"A1VC38T7YXB528","currency":"JPY",'url':'https://sellercentral.amazon.co.jp/fba/profitabilitycalculator/','host':2},
            'UK':{"lang":"en_GB","marketPlace":"A1F83G8C2ARO7P","currency":"GBP",'url':'https://sellercentral.amazon.co.uk/fba/profitabilitycalculator/','host':3},
            'IT':{"lang":"it_IT","marketPlace":"APJ6JRA9NG5V4","currency":"EUR",'url':'https://sellercentral.amazon.co.uk/fba/profitabilitycalculator/','host':3},
            'ES':{"lang":"es_ES","marketPlace":"A1RKKUPIHCS9HS","currency":"EUR",'url':'https://sellercentral.amazon.co.uk/fba/profitabilitycalculator/','host':3},
            'FR':{"lang":"fr_FR","marketPlace":"A13V1IB3VIYZZH","currency":"EUR",'url':'https://sellercentral.amazon.co.uk/fba/profitabilitycalculator/','host':3},
            'DE':{"lang":"de_DE","marketPlace":"A1PA6795UKMFR9","currency":"EUR",'url':'https://sellercentral.amazon.co.uk/fba/profitabilitycalculator/','host':3}}
asin_list = {'US':['B01N5YAZSD','B01MEHY361','B06XTFNTJ1'],
            'CA':['B00TMZ2FY8','B00N1KJ3C2','B001MK90HQ'],
            'MX':['','',''],
            'JP':['B00N2K5TH4','B01FA9G9NM','B00SF4MWU4'],
            'UK':['B07174MQ9J','B00DPC015E','B072FNXGFB'],
            'IT':['B071F8GLRT','B06Y649Z15','B071J2PWWP'],
            'ES':['B06XGZG2ZG','B06XWLPPZ1','B06ZYWZBNL'],
            'FR':['B072C34184','B06X1D3T9N','B01MDTQLU5'],
            'DE':['B072J9FW9H','B07175JY6L','B00ILZCGEY']}

price_list = {'US':{'high':35,'low':0.02},'CA':{'high':35,'low':0.02},'MX':{'high':115,'low':0.02},'JP':{'high':1020,'low':1},'UK':{'high':35,'low':0.02},
            'IT':{'high':35,'low':0.02},'ES':{'high':35,'low':0.02},'FR':{'high':35,'low':0.02},'DE':{'high':35,'low':0.02}}

tool=httptools.httptools()

heads={
    'Accept':'text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,*/*;q=0.8',
    'Accept-Language':'en-US,en;q=0.8,zh-CN;q=0.6,zh;q=0.4',
    'Connection':'keep-alive',
#     'Content-Type':'application/x-www-form-urlencoded',
#     'Cookie':'session-token=v3h8+My6E/SinWsQCAjGG53K9wE4GaXPSHioISvCmCVZxTWXJKqQ/16tXycLeEqLGdLaukfS3Yr5qTOev7maRF8YoPa0lLb68cbmsLQBUCP+p1LTKG8JgV5MGI1TQUDxoTNcsscyhbV8wNUn/VDApbVWJ/TSlZu3R0GNhjOJ4wpZWWpM01uImQd2mkbotdOJu8LSb/Jz0vOXuJLWhTmgJ64/n+a7G+MdW7NE0iPAMolFRmFEhDz1oHAiHjWRMQxs0FKd2tMigf1F3MjJEIn8kQH7rrepzrV0; x-main="FXcn34DH6wJW?aOpMAcgT6jfnXIWb4ke6dJ9lDrjqik6ZQumUt2jkgcC6r5m8KFb"; at-main="5|hbrOO6uXYDP32sNYGWjpU+kZ/Z2eCBvr54miIXiRSmehwIRGwqM3hjSgD4tFlBIOfarbL4BgEzldKtxSbYGVPQNEuJIwARenxNEs8Tbpnbcd5UELe1lL5mIHITbirVOQwWQxFVccFqIMn/Mg3RNsqn9rP6S3IdrmTwNWC8NxhrkIzYGmPuS/hXJifXk7MblEN2YdSi+ZuD5bm7Rhkm0w+Rpvp4J0XZbEMHlC7Fm9BQQ="; x-wl-uid=1M7Yc2qCjVOI/02g+uY8QD+jnDSwB4/9ehiSQ7AEd6JpFx5iz/Ov7r3gtodgDrDsOuErV1yVRAMk9HIru4diKHqumX6Vs13doHn4NPz+6KFfqSAGFpvb8ffusf2Xryw6cgCIFj6W0bO4=; _mkto_trk=id:810-GRW-452&token:_mch-amazon.com-1418188330112-52950; s_ppv=100; __utma=194891197.1154938318.1418197518.1418197518.1418199803.2; __utmc=194891197; __utmz=194891197.1418199803.2.2.utmccn=(referral)|utmcsr=exmail.qq.com|utmcct=/cgi-bin/mail_spam|utmcmd=referral; aws_lang=cn; s_vn=1449624626115%26vn%3D2; s_fid=0B908A6B529C0FD4-216D4F7B45C9B464; s_sess=%20s_ppvl%3DUS%25253AAS%25253AFBA-pricing%252C85%252C85%252C1786%252C1024%252C620%252C1024%252C768%252C1%252CL%3B%20s_ppv%3DUS%25253AAS%25253AFBA-pricing%252C83%252C29%252C1733%252C1024%252C620%252C1024%252C768%252C1%252CL%3B%20s_cc%3Dtrue%3B%20s_sq%3Dawsamazonprod2%252Cawsamazonallprod2%253D%252526pid%25253Dconsole%252526pidt%25253D1%252526oid%25253Dhttp%2525253A%2525252F%2525252Faws.amazon.com%2525252Fdatasets%2525253F_encoding%2525253DUTF8%25252526jiveRedirect%2525253D1%252526ot%25253DA%3B; s_cc=true; s_sq=%5B%5BB%5D%5D; skin=noskin; session-id-time=1418803200l; session-id=180-4684602-4004811; pN=52; s_pers=%20s_fid%3D5570A79AE898C50B-2C18CCCA9C7C6BC2%7C1481347273669%3B%20s_ev15%3D%255B%255B%2527AS%2527%252C%25271418188873713%2527%255D%255D%7C1575955273713%3B%20s_dl%3D1%7C1418197887067%3B%20gpv_page%3DUS%253ASC%253A%2520SellerCentralLogin%7C1418197887085%3B%20s_vnum%3D1850020092413%2526vn%253D3%7C1850020092413%3B%20s_invisit%3Dtrue%7C1418205841993%3B%20s_nr%3D1418204042009-Repeat%7C1425980042009%3B; s_vnum=1850200298031%26vn%3D3; s_nr=1418205996557-New; s_invisit=true; s_dslv=1418205996559; s_dslv_s=Less%20than%201%20day; s_c27=1161240; csm-hit=4.51|1418206018005; ubid-main=182-6039978-2160424',
#     'DNT':'1',
    'Host':'sellercentral.amazon.com',
    'Origin':'https//sellercentral.amazon.com',
    #'Referer':'https//sellercentral.amazon.com/gp/fba/revenue-calculator/index.html/ref=xx_xx_cont_xx?ie=UTF8&lang=en_US',
    'User-Agent':'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2272.101 Safari/537.36',
#     'X-Requested-With':'XMLHttpRequest',
}
# url1='https://sellercentral.amazon.com/gp/fba/revenue-calculator/data/product-matches.html'
url0 ='https://sellercentral.amazon.com/hz/fba/profitabilitycalculator/index?lang=en_US'
url1='https://sellercentral.amazon.com/fba/profitabilitycalculator/productmatches?searchKey=%s&language=en_US&profitcalcToken=%s'
url2='https://sellercentral.amazon.com/gp/fba/core/data/models/mfn-fees.html'
url3='https://sellercentral.amazon.com/gp/fba/core/data/models/afn-fees.html'

#url_new0 = 'https://sellercentral.amazon.com/fba/profitabilitycalculator/index?lang=en_US'
#url_new1 = 'https://sellercentral.amazon.com/fba/profitabilitycalculator/productmatches?searchKey=%s&language=en_US&profitcalcToken=%s'
#url_new2 = 'https://sellercentral.amazon.com/fba/profitabilitycalculator/getafnfee?profitcalcToken=%s'


def getcost_for_amazon(asin,weight):
    print 'getcost_for_amazon'
    html = tool.gethtml(url0,heads = heads)
    token = re.search(r"<input type='hidden' name='profitcalcToken' value='(\w*)'",html).group(1)
    #print token
    url = url1 %(asin,token)
    postdata1=json.loads('{"lang":"en_US","marketPlace":"ATVPDKIKX0DER"}')
    #postdata1['searchString']=asin
    #postdata1='method=GET&model='+urllib.quote(json.dumps(postdata1))
    resutl1=None
    try:    
        html1=tool.gethtml(url,heads=heads)
        print 'html1:'
        print html1
        resutl1=json.loads(html1)
    except Exception,e:
        print e
    if not resutl1:
        return (0,0)
    if not resutl1['data']:
        return (-1,-1)
    resutl1=resutl1['data'][0]
    postdic=json.loads('{"selected":true,"":"N","language":"en_US","shipping":0,"revenueTotal":0.5,"order-handling":0,"pick-pack":0,"outbound-delivery":0,"storage":0,"inbound-delivery":0,"customer-service":0,"prep-service":0,"fulfillmentTotal":0}')
    keys=resutl1.keys()
    for key in keys:
        print key
        if key=='dimensions':
            if resutl1[key]['width']=='':
                resutl1[key]['width']=2
                resutl1[key]['height']=2
                resutl1[key]['length']=2
                resutl1[key]['weight']=weight
            postdic[key]=resutl1[key]
            continue
        postdic[key]=resutl1[key]
    postdic['price']=0.01
    postdata1='method=GET&model='+urllib.quote(json.dumps(postdic))
    postdic['price']=51
    postdata2='method=GET&model='+urllib.quote(json.dumps(postdic))
    try:
        print 'd0'
        print postdata1
        html2=tool.gethtml(url3,postdata1,heads).strip()
        print html2
        d1=json.loads(html2)
        print 'd1'
        html3=tool.gethtml(url3,postdata2,heads).strip()
        print html3
        d2=json.loads(html3)
        print 'd2'
        return d1,d2
    except Exception, e:
        print 'error 2'
        print e
        return (0,0)


def getcost_for_amazon_new(site, asin, weight, width=2, height=2, length=2):
    print 'getcost_for_amazon_new'
    url_new0 = market_list[site]['url']+'index?lang='+market_list[site]['lang']
    url_new1 = market_list[site]['url']+'productmatches?searchKey=%s&language='+market_list[site]['lang']+'&profitcalcToken=%s'
    url_new2 = market_list[site]['url']+'getafnfee?profitcalcToken=%s'

    if market_list[site]['host'] == 1:
        heads['Host'] = 'sellercentral.amazon.com'
    elif market_list[site]['host'] == 2:
        heads['Host'] = 'sellercentral.amazon.co.jp'
    elif market_list[site]['host'] == 3:
        heads['Host'] = 'sellercentral.amazon.co.uk'
    try:
        html = tool.gethtml(url_new0,heads = heads)
        token = re.search(r"<input type='hidden' name='profitcalcToken' value='(\w*)'",html).group(1)
    except Exception,e:
        print 'error 0'
        print e
        return (-1,-1)

    print token
    
    url = url_new1 %(asin,token)
    #postdata1=json.loads('{"lang":"en_US","marketPlace":"ATVPDKIKX0DER"}')
    resutl1=None
    try:
        heads['Content-Type'] = 'application/json;charset=UTF-8'
        html1=tool.gethtml(url,heads=heads)
        #print [html1]
        html11 = html1.decode('utf-8').encode("utf-8")
        #print html11  
        resutl1=json.loads(html11)
        print resutl1
    except Exception,e:
        print 'error 1'
        print e
    if not resutl1:
        print 'product match fail1'
        return (-1,-1)
    if not resutl1['data']:
        print 'product match fail2'
        return (-1,-1)
    resutl1=resutl1['data'][0]
    #print resutl1

    get_width = resutl1.get('width',0)
    if get_width == 0:
        resutl1['width'] = width
    get_height = resutl1.get('height',0)
    if get_height == 0:
        resutl1['height'] = height
    get_length = resutl1.get('length',0)
    if get_length == 0:
        resutl1['length'] = length
    get_weight = resutl1.get('weight',0)
    if get_weight == 0:
        resutl1['weight'] = weight
    #print get_width,get_height,get_length,get_weight

    url = url_new2 %(token)
    try:
        price_low = price_list[site]['low']
        price_high = price_list[site]['high']
        mfn_fee_low = get_mfnfee(price_low,market_list[site]['currency'],url,heads,market_list[site]['marketPlace'],resutl1)
        mfn_fee_high = get_mfnfee(price_high,market_list[site]['currency'],url,heads,market_list[site]['marketPlace'],resutl1)
        #print mfn_fee_high
        return (mfn_fee_low,round(float(mfn_fee_high/price_high),4))
    except Exception, e:
        print 'error 2'
        print e
        return (-1,-1)


def get_mfnfee(price,currency,url,heads,marketPlaceId,product_info):
    postdic = {"afnPriceStr":0,"mfnPriceStr":price,"mfnShippingPriceStr":0,"currency":currency,"marketPlaceId":marketPlaceId,"hasFutureFee":False,"futureFeeDate":"2017-03-03 00:00:00","hasTaxPage":True,'productInfoMapping':product_info}
    #print postdic
    heads['Content-Type'] = 'application/json;charset=UTF-8'
    html2=tool.gethtml_new(url,postdic,heads).strip()
    #print html2
    html_data=json.loads(html2)
    #print 'html_data: ', html_data
    all_data = html_data.get('data',{})
    if all_data:
        mfnFees = all_data.get('mfnFees',{})
        if mfnFees:
            referralFee = mfnFees.get('referralFee',{})
            if referralFee:
                return float(referralFee.get('amount',-1))
            else:
                print 'referralFee'
                return -1
        else:
            print 'mfnFees'
            return -1
    else:
        print 'data'
        return -1


def handle(asin):
    asin=asin.strip()
    d1,d2=getcost_for_amazon(asin,2)
    if d1==-1:
        lock.acquire()
        result_file.write(asin+"\t\t\t\t\t\t\t\t"+"-1"+"\n")
        result_file.flush()
        lock.release()
        return
    if d1==0:
        lock.acquire()
        result_file.write(asin+"\t\t\t\t\t\t\t\t"+"0"+"\n")
        result_file.flush()
        lock.release()    
        return
    if d1!=None and d2!=None:
        if d1['data']!=None and d2['data']!=None:
            d1=d1['data']
            d2=d2['data']
            try:
                commissionFee_low=float(d1['commissionFee'])
            except Exception, e:
                commissionFee_low=-1
            try:
                variableClosingFee=float(d2['variableClosingFee'])
            except Exception, e:
                variableClosingFee=-1
            try:
                commissionFee_rate=float(d2['commissionFee'])/51
            except Exception, e:
                commissionFee_rate=-1
            
            #  for FBA cost
            try:
                order_handling = float(d2['orderHandlingFee'])
            except Exception, e:
                order_handling=-1
            try:
                pick_pack = float(d2['pickAndPackFee'])
            except Exception, e:
                pick_pack = -1
            try:
                weight_handling = float(d2['weightHandlingFee'])
            except Exception, e:
                weight_handling = -1
            try:
                day_30_storage = float(d2['storageFee'])
            except Exception, e:
                day_30_storage=-1
            temp_write=[asin,str(commissionFee_rate),str(commissionFee_low),str(variableClosingFee),str(order_handling),str(pick_pack),str(weight_handling),str(day_30_storage),'1']
            lock.acquire()
            result_file.write("\t".join(temp_write)+"\n")
            result_file.flush()
            lock.release()


def start(sfile,dfile):
    global lock,result_file
    lock=Lock()
    f=open(sfile)
    f.readline()
    asins=f.readlines()
    f.close()
    result_file=open(dfile,'a')
    result_file.close()
    result_file=open(dfile,'r+')
    result_file.seek(0)
    titles=['asin','commissionFee_rate','commissionFee_low','variableClosingFee','orderHandlingFee','pickAndPackFee','weightHandlingFee','storageFee',"status"]
    result_file.write("\t".join(titles)+"\n")
    result_file.flush()
    result_file.close()
    result_file=open(dfile,"a")
    pool=Pool(30)
    pool.map(handle,asins)
    pool.close()
    pool.join()
    result_file.close()


def ex():
    f=open("amazon_price_rate.csv")
    f.readline()
    price_rates=f.readlines()
    f.close()
    with open("amazonasins.txt") as f:
        lines=f.readlines()
    old_asin=set()
    for l in lines:
        old_asin.add(l.strip())
    fail_asins=set()
    do_asin=set()
    result_file=open("amazon_price_rate.csv","w")
    titles=['asin','commissionFee_rate','commissionFee_low','variableClosingFee','orderHandlingFee','pickAndPackFee','weightHandlingFee','storageFee',"status"]
    result_file.write("\t".join(titles)+"\n")
    for price_rate in price_rates:
        args=price_rate.strip().split("\t")
        do_asin.add(args[0])
        if args[8]=="0":
            fail_asins.add(args[0])
        else:
            result_file.write(price_rate)
    result_file.flush()
    result_file.close()
    asins=old_asin-do_asin|fail_asins
    print len(asins)
    f=open("amazonasins.txt","w")
    f.write("\n".join(asins))
    f.flush()
    f.close()


if __name__=='__main__':
    import time
    '''
    status 
    1 nor
    0 error
    -1 not find
    '''
#    while True:
#        start("amazonasins.txt","amazon_price_rate.csv")
#         ex()
    #for asin in asin_list['JP']:
    print getcost_for_amazon_new('CA','B075L7GZ59',0.5)  # "B00FF65FEA"
#     ex()
'''
    print time.strftime("%Y-%m-%d %H:%M:%S", time.localtime())  
    with open('asin_list.csv', 'r') as asin_list_file:
        lines = asin_list_file.readlines()
        for l in lines:
            extra_info = l.split(',')
            asin = extra_info[0]
            site = extra_info[1].upper()
            print asin,site
            print getcost_for_amazon_new(site,asin,0.5)
            time.sleep(0.2)
    print time.strftime("%Y-%m-%d %H:%M:%S", time.localtime()) 
'''
